!c Description:
!c   ͤ⾯ʤʤäǤ򥫥å
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-03-01    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_chk_emolfr
  interface
     
     subroutine chk_emolfr(emol, mol, struct, EPSZ, ssw, esw, sw)
       real(8), intent(in)               :: emol(:)
       real(8), intent(in)               :: mol(:)
       real(8), intent(in)               :: EPSZ
       real(8), intent(in)               :: struct(:,:)
       logical, intent(out), allocatable :: ssw(:)
       logical, intent(out), allocatable :: esw(:)
       logical, intent(out)              :: sw
     end subroutine chk_emolfr
     
  end interface
end module interface_chk_emolfr




subroutine chk_emolfr(emol, mol, struct, EPSZ, ssw, esw, sw)
  use prm_common, only: debug
  use interface_packing
  use interface_display

  implicit none
  real(8), intent(in)               :: emol(:)  
  real(8), intent(in)               :: mol(:)  
  real(8), intent(in)               :: EPSZ
  real(8), intent(in)               :: struct(:,:)
  logical, intent(out), allocatable :: ssw(:)
  logical, intent(out), allocatable :: esw(:)
  logical, intent(out)              :: sw
  
  real(8), allocatable              :: emolfr(:,:)  !ǤΥ
  real(8), allocatable              :: emolfr_max(:)
  real(8), allocatable              :: struct_tmp(:,:)
  integer                           :: e, s
  integer                           :: N, M


!!!
!!!ͺ
!!!
  N = size(struct, 1)
  M = size(struct, 2)

  if (allocated(ssw)) deallocate(ssw)
  if (allocated(esw)) deallocate(esw)
  allocate(ssw(N), esw(M), emolfr(N,M), emolfr_max(N))
  ssw = .true.; esw = .true.; sw = .false. 

  
!!!
!!!Ʋؼθ/ 
!!!
  do s = 1, N
     emolfr(s,:) = struct(s,:) * mol(s)
  end do

  do e = 1, M
     emolfr(:,e) = emolfr(:,e) / emol(e)
  end do
!  call display(emolfr, "emolfr")

!!!
!!!٤ؼ, Ǥܺ
!!!
  !ƲؼΤʤ, emolfr Ǥ礭ͤȴФ
  emolfr_max = maxval(emolfr, 2)
  if (debug) call display(emolfr_max, "emolfr_max")
  
  !emolfr_max κǾͤ
  s = minloc(emolfr_max, 1)
!  write(*,*) s, emolfr_max(s), EPSZ
  
  !emolfr_max κǾͤ礭Ƚ. ˤϺ
  if (emolfr_max(s) < EPSZ) then 
!     write(*,*) "delete species"
     ssw(s) = .false. 
     sw = .true. 
  end if
  
  !Ǥ̵ʤäƤޤä
  call packing(struct, ssw, esw, struct_tmp)
  esw = sum(struct_tmp,1) /= 0.0d0

!!!
!!!դ
!!!
  deallocate(emolfr, emolfr_max)

end subroutine chk_emolfr
